## libodsstream 0.6.2-3ubuntu1

=== CMakeLists.txt ===
# cmake helps to compile "libodsstream"
# please install the cmake package depending on your linux distribution
# and type in the libodsstream root directory :
# cmake .
# make
# make install
cmake_minimum_required(VERSION 2.6)

PROJECT(libodsstream CXX C)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)


IF(NOT USEQT4)
  IF(NOT USEQT5)
    SET (USEQT5 1)
  ENDIF(NOT USEQT5)
ENDIF(NOT USEQT4)

# Project version
# 

SET (LIBODSSTREAM_MAJOR_VERSION 0)
SET (LIBODSSTREAM_MINOR_VERSION 6)
SET (LIBODSSTREAM_PATCH_LEVEL   2)
SET (LIBODSSTREAM_VERSION
  "${LIBODSSTREAM_MAJOR_VERSION}.${LIBODSSTREAM_MINOR_VERSION}.${LIBODSSTREAM_PATCH_LEVEL}")
SET (LIBODSSTREAM_LIB_NAME "libodsstream")
SET (LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
SET (LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_MAJOR_VERSION})

#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
if (CMAKE_VERSION VERSION_LESS "3.1")
    if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        set (CMAKE_CXX_FLAGS "-std=gnu++11 ${CMAKE_CXX_FLAGS}")
    endif ()
else ()
    set (CMAKE_CXX_STANDARD 14)
endif ()

if (NOT CMAKE_INSTALL_PREFIX)
  SET (CMAKE_INSTALL_PREFIX /usr/local)
endif (NOT CMAKE_INSTALL_PREFIX)

if (NOT CMAKE_BUILD_TYPE)
#SET(CMAKE_BUILD_TYPE "Release")
#SET(CMAKE_BUILD_TYPE "RelWithDebInfo")
SET( CMAKE_BUILD_TYPE "Debug")
endif (NOT CMAKE_BUILD_TYPE)
MESSAGE("CMAKE_BUILD_TYPE : ${CMAKE_BUILD_TYPE}")

IF(CMAKE_BUILD_TYPE MATCHES "Release")
  MESSAGE("compiling as release version")
  ADD_DEFINITIONS("-DQT_NO_DEBUG_OUTPUT")
ENDIF( CMAKE_BUILD_TYPE MATCHES "Release" )

IF(CMAKE_BUILD_TYPE MATCHES "Debug")
  MESSAGE("compiling as debug version")
  set (MAKE_TEST 1)
ENDIF( CMAKE_BUILD_TYPE MATCHES "Debug" )

IF(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
  MESSAGE("compiling as release with debug info version")
ENDIF( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )


SET(CPACK_CMAKE_GENERATOR "Unix Makefiles")
SET(CPACK_GENERATOR "STGZ;TGZ;TZ")
SET(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
#SET(CPACK_PACKAGE_DESCRIPTION_FILE ${LIBODSSTREAM_SOURCE_DIR}/COPYING)
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "library to read and write ODS files using streams")
SET(CPACK_PACKAGE_EXECUTABLES "libodsstream")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")
SET(CPACK_SYSTEM_NAME "Linux-i686")
SET(CPACK_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}-${CPACK_SYSTEM_NAME}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "libodsstream ${LIBODSSTREAM_VERSION}")
SET(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "libodsstream ${LIBODSSTREAM_VERSION}")
SET(CPACK_PACKAGE_NAME "libodsstream")
SET(CPACK_PACKAGE_VENDOR "PAPPSO")
SET(CPACK_PACKAGE_VERSION ${LIBODSSTREAM_VERSION})
SET(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/debian/copyright)
SET(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README)
SET(CPACK_RESOURCE_FILE_WELCOME ${CMAKE_SOURCE_DIR}/README)
SET(CPACK_SOURCE_GENERATOR "TGZ;TZ")
SET(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
SET(CPACK_SOURCE_STRIP_FILES "")
SET(CPACK_SYSTEM_NAME "Linux-i686")
SET(CPACK_TOPLEVEL_TAG "Linux-i686")
SET(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")


SET(CPACK_SOURCE_IGNORE_FILES 
  ".*\\\\.tar\\\\.gz"
  "moc_.*cxx"
  "\\\\.#.*"
  ".*\\\\.aux"
  ".*\\\\.bbl"
  ".*\\\\.blg"
  ".*\\\\.log"
  ".*\\\\.out"
  ".*\\\\.toc"
  "/devel_archives/"
  "/doc\\\\/html/"
  "/doc\\\\/latex/"
  "Makefile"
  "install_manifest.txt"
  "CMakeCache.txt"
  "CPackConfig.cmake"
  "CPackSourceConfig.cmake"
  "/CMakeFiles/"
  "/_CPack_Packages/"
  "/Debug/"
  "/Release/"
  "/tests/"
  "/\\\\.externalToolBuilders/"
  "/\\\\.git/"
  "/\\\\.kdev4/"
  "/\\\\.settings/"
  "Makefile"
  "\\\\.gitignore"
  "\\\\.cdtbuild"
  "\\\\.cdtproject"
  "\\\\.project"
  "\\\\.cproject"
  "/win32/"
  "/win64/"
  "/build/"
  "/buildwin64/"
  "/cbuild/"
  "/bin/"
  "/buildmingw/"
  "test\\\\.ods"
  "buildwin32.cmd"
  "libodsstream.so"
  "OpenDocument-v1.0-os.pdf"
  )
# to create a TGZ archive of the  source code type shell command
# cpack -G TGZ --config CPackSourceConfig.cmake 

# dpkg-buildpackage -rfakeroot -k7BEF3B25

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#dch -Dstretch "message"
#cmake ..
#make deb
# scp libodsstream* proteus:/var/www/apt/incoming
# scp ods2tsv* proteus:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default


#dpkg-deb -x libodsstream-qt4_0.3.0-3_amd64.deb libodsstream-qt4_0.3.0-3
#dpkg-gensymbols -v0 -plibodsstream-qt4 -Plibodsstream-qt4_0.3.0-3 -Osymbols
#cp symbols ../debian/libodsstream-qt4.symbols
#dpkg-deb -x libodsstream-qt5_0.3.0-3_amd64.deb libodsstream-qt5_0.3.0-3
#dpkg-gensymbols -v0 -plibodsstream-qt5 -Plibodsstream-qt5_0.3.0-3 -Osymbols
#cp symbols ../debian/libodsstream-qt5.symbols

#MESSAGE("configuring file ${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake")

#configure_file (${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake ${LIBODSSTREAM_SOURCE_DIR}/src/config.h)



SET(CPACK_PACKAGE_EXECUTABLES "libodsstream" "libodsstream")


# for debian package :
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Olivier Langella <olivier.langella@u-psud.fr>")
SET(DEBIAN_PACKAGE_BUILDS_DEPENDS "Olivier Langella <olivier.langella@u-psud.fr>")


INCLUDE(CPack)

add_subdirectory (src)

add_subdirectory (doc)

add_custom_target(targz
	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libodsstream-${LIBODSSTREAM_VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating .tar.gz" VERBATIM
)


add_custom_target(deb
	cd libodsstream-${LIBODSSTREAM_VERSION} && dpkg-buildpackage 
	DEPENDS targz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating Debian package" VERBATIM
)


IF(MAKE_TEST)
  ENABLE_TESTING()
  INCLUDE(CTest)
  IF (BUILD_TESTING)
    ADD_SUBDIRECTORY(test)
  ENDIF(BUILD_TESTING)
ENDIF(MAKE_TEST)



# Install cmake module
INSTALL(FILES modules/FindOdsstream.cmake DESTINATION share/cmake/Modules)
# Install cmake config
configure_file (${CMAKE_SOURCE_DIR}/modules/OdsstreamConfig.cmake ${CMAKE_SOURCE_DIR}/OdsstreamConfig.cmake)
INSTALL(FILES ${CMAKE_SOURCE_DIR}/OdsstreamConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)

=== src/CMakeLists.txt ===

if (MINGW)
else (MINGW)
    #find zlib
    FIND_PACKAGE(ZLIB REQUIRED)
    set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/modules)
    FIND_PACKAGE(QuaZip REQUIRED)
endif (MINGW)

INCLUDE_DIRECTORIES(${ZLIB_INCLUDE_DIR})
#INCLUDE_DIRECTORIES(${QUAZIP_INCLUDE_DIRS})


#SET (QT_USE_QTXMLPATTERNS true)



SET(CPP_FILES 
  odsstream/reader/odscell.cpp
  odsstream/odsexception.h 
  odsstream/saxreader/saxhandlercontentxml.cpp 
  odsstream/odsdocreader.cpp
  odsstream/writer/options/odscolorscale.cpp
  odsstream/writer/options/odstablecellstyle.cpp
  odsstream/writer/options/odstablecellstyleref.cpp
  odsstream/writer/options/odstablesettings.cpp
  odsstream/writer/structure/stylesxml.cpp
  odsstream/writer/structure/contentxml.cpp
  odsstream/writer/structure/metaxml.cpp
  odsstream/writer/structure/settingsxml.cpp
  odsstream/writer/structure/manifestxml.cpp
  odsstream/odsdocwriter.cpp
  odsstream/tsvdirectorywriter.cpp
  odsstream/tsvoutputstream.cpp
)



SET(ODS2CSV_CPP_FILES 
  ods2csv.cpp
)



configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)

IF (USEQT5)
    MESSAGE ("LIBODSSTREAM_LIB_SOVERSION: ${LIBODSSTREAM_LIB_SOVERSION}")
  #qt5-default qtbase5-dev
  FIND_PACKAGE( Qt5Core REQUIRED )
  FIND_PACKAGE( Qt5Xml REQUIRED )
  FIND_PACKAGE( Qt5Gui REQUIRED )

  # Build the static lib
  ADD_LIBRARY(odsstream-static-qt5 STATIC ${CPP_FILES})
  target_include_directories (odsstream-static-qt5 PUBLIC ${Qt5Xml_INCLUDES} ${Qt5Core_INCLUDES} ${Qt5Gui_INCLUDES} ${QUAZIP_INCLUDE_DIR})
    
    SET_TARGET_PROPERTIES(odsstream-static-qt5
      PROPERTIES OUTPUT_NAME odsstream-qt5
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
    )
  TARGET_LINK_LIBRARIES(odsstream-static-qt5 ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES}  ${QUAZIP_QT5_LIBRARIES} ${Qt5Core_LIBRARIES})

  # Build the shared lib
  ADD_LIBRARY(odsstream-shared-qt5 SHARED ${CPP_FILES})
  target_include_directories (odsstream-shared-qt5 PUBLIC ${Qt5Xml_INCLUDES} ${Qt5Core_INCLUDES} ${Qt5Gui_INCLUDES} ${QUAZIP_INCLUDE_DIR})
  SET_TARGET_PROPERTIES(odsstream-shared-qt5 PROPERTIES 
    OUTPUT_NAME odsstream-qt5
    VERSION ${LIBODSSTREAM_LIB_VERSION}
    SOVERSION ${LIBODSSTREAM_LIB_SOVERSION}
    CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}"
    CLEAN_DIRECT_OUTPUT 1
    )
  TARGET_LINK_LIBRARIES(odsstream-shared-qt5 PUBLIC ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES} ${QUAZIP_QT5_LIBRARIES} )

  # Install libs
  if (MINGW)
	  INSTALL(TARGETS odsstream-shared-qt5 RUNTIME DESTINATION lib${LIB_SUFFIX})
  else (MINGW)
    INSTALL(TARGETS odsstream-shared-qt5 LIBRARY DESTINATION lib${LIB_SUFFIX})
  endif(MINGW)
  INSTALL(TARGETS odsstream-static-qt5 DESTINATION lib${LIB_SUFFIX})
  
  ADD_EXECUTABLE(ods2csv ${ODS2CSV_CPP_FILES})
  target_include_directories (ods2csv PUBLIC ${Qt5Core_INCLUDES} "${CMAKE_SOURCE_DIR}/src" )
  SET_TARGET_PROPERTIES(ods2csv
      PROPERTIES OUTPUT_NAME ods2tsv
      CLEAN_DIRECT_OUTPUT 1
      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}"
    )
  TARGET_LINK_LIBRARIES(ods2csv odsstream-shared-qt5 ${Qt5Core_LIBRARIES})

  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/ods2tsv DESTINATION bin)

ENDIF(USEQT5)

IF (USEQT4)
  #qt5-default qtbase5-dev
  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
  
  MESSAGE ("QT_DEFINITIONS ${QT_DEFINITIONS}" )
  MESSAGE ("QT_INCLUDE_DIR ${QT_INCLUDE_DIR}" )
  MESSAGE ("QT_QTCORE_INCLUDE_DIR ${QT_QTCORE_INCLUDE_DIR}" )
  MESSAGE ("QT_QTXML_INCLUDE_DIR ${QT_QTXML_INCLUDE_DIR}" )
  

  # Build the static lib
  ADD_LIBRARY(odsstream-static-qt4 STATIC ${CPP_FILES})
  if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
       target_include_directories (odsstream-static-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
   else()
       include_directories(${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
   endif()
  IF (MINGW)
    SET_TARGET_PROPERTIES(odsstream-static-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      )
  ELSE (MINGW)
    SET_TARGET_PROPERTIES(odsstream-static-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      COMPILE_DEFINITIONS "${QT_DEFINITIONS}"
      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
      )
  ENDIF (MINGW)
  TARGET_LINK_LIBRARIES(odsstream-static-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})

  # Build the shared lib
  ADD_LIBRARY(odsstream-shared-qt4 SHARED ${CPP_FILES})
  if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
    target_include_directories (odsstream-shared-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})

   else()
       include_directories(${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
   endif()
  IF(MINGW)
    SET_TARGET_PROPERTIES(odsstream-shared-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      VERSION ${LIBODSSTREAM_VERSION}
      SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
      )
  ELSE (MINGW)
    SET_TARGET_PROPERTIES(odsstream-shared-qt4
      PROPERTIES OUTPUT_NAME odsstream-qt4
      CLEAN_DIRECT_OUTPUT 1
      VERSION ${LIBODSSTREAM_VERSION}
      SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
      COMPILE_DEFINITIONS "${QT_DEFINITIONS}"
      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
      )
  ENDIF (MINGW)
  TARGET_LINK_LIBRARIES(odsstream-shared-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})

  # Install libs
  INSTALL(TARGETS odsstream-shared-qt4 LIBRARY DESTINATION lib${LIB_SUFFIX})
  INSTALL(TARGETS odsstream-static-qt4 DESTINATION lib${LIB_SUFFIX})

ENDIF(USEQT4)



# Install headers
INSTALL(DIRECTORY odsstream/ DESTINATION include/odsstream FILES_MATCHING PATTERN "*.h")

=== test/CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Author: Olivier Langella
# Created: 03/03/2015 from the CMakeLists file of the Bio++ project

#CTEST_OUTPUT_ON_FAILURE=TRUE make test
#make test ARGS="-V"

configure_file (config.h.cmake ${CMAKE_SOURCE_DIR}/test/config.h)

MACRO(TEST_FIND_LIBRARY OUTPUT_LIBS lib_name include_to_find)
  #start:
  FIND_PATH(${lib_name}_INCLUDE_DIR ${include_to_find})

  SET(${lib_name}_NAMES ${lib_name} ${lib_name}.lib ${lib_name}.dll)
  FIND_LIBRARY(${lib_name}_LIBRARY NAMES ${${lib_name}_NAMES})
  IF(${lib_name}_LIBRARY)
    MESSAGE("-- Library ${lib_name} found here:")
    MESSAGE("   includes: ${${lib_name}_INCLUDE_DIR}")
    MESSAGE("   dynamic libraries: ${${lib_name}_LIBRARY}")
    MESSAGE(WARNING "Library ${lib_name} is already installed in the system tree. Test will be built against it. This may lead to unexpected results. You may want to do 'make install' before 'make test', or remove the installed version.")
  ELSE()
    MESSAGE("${lib_name}_LIBRARY -L../src -l${lib_name}")
    MESSAGE("${lib_name}_INCLUDE_DIR ../src/")
    MESSAGE("${LIBS}")
    SET(${lib_name}_LIBRARY "-L../src -l${lib_name}")
    SET(${lib_name}_INCLUDE_DIR "../src/")
  ENDIF()
  
    SET(${lib_name}_LIBRARY "-L../src -l${lib_name}")
    SET(${lib_name}_INCLUDE_DIR "../src/")
  INCLUDE_DIRECTORIES(${${lib_name}_INCLUDE_DIR})
  SET(${OUTPUT_LIBS} ${${OUTPUT_LIBS}} ${${lib_name}_LIBRARY})
ENDMACRO(TEST_FIND_LIBRARY)


# File list
SET(CPP_TEST_FILES
  
  )
  

IF (USEQT5)
  IF (USEQT4)
     SET (USEQT5 1)
     SET (USEQT4 0)
  ENDIF(USEQT4)
ENDIF(USEQT5)

IF (USEQT5)
  #Find the bpp-core library library:
  TEST_FIND_LIBRARY(LIBS odsstream-qt5 odsstream/odsdocreader.h)

  FIND_PACKAGE( Qt5Core REQUIRED )
  FIND_PACKAGE( Qt5Xml REQUIRED )
  FIND_PACKAGE( Qt5Gui REQUIRED )
  INCLUDE_DIRECTORIES(${Qt5Core_INCLUDES} ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES})
  SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}")
 
  set(QTLIBS ${Qt5Core_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES})
ENDIF(USEQT5)

IF (USEQT4)
  #Find the bpp-core library library:
  TEST_FIND_LIBRARY(LIBS odsstream-qt4 odsstream/odsdocreader.h)

  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
  
  INCLUDE( ${QT_USE_FILE} )
  set(QTLIBS "${QT_LIBRARIES}")
ENDIF(USEQT4)

ADD_EXECUTABLE(test_ods test_ods.cpp)
MESSAGE ("library: ${LIBS}")
TARGET_LINK_LIBRARIES(test_ods ${LIBS} ${QTLIBS})
ADD_TEST(test_ods "test_ods")


ADD_EXECUTABLE(test_tsv test_tsv.cpp)
TARGET_LINK_LIBRARIES(test_tsv ${LIBS} ${QTLIBS})
ADD_TEST(test_tsv "test_tsv")


IF(UNIX)
  SET_PROPERTY(TEST test_ods test_tsv ${TEST_LIST} PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
ENDIF()

IF(WIN32)
  SET(ENV{PATH} "$ENV{PATH};..\\src")
ENDIF()

=== debian/changelog ===
libodsstream (0.6.2-3ubuntu1) trusty; urgency=medium

  * deb package for Ubuntu 14.04

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 21 Aug 2018 11:59:09 +0000

libodsstream (0.6.2-3) stretch; urgency=medium

  * ODS reader problem is fixed

 -- Olivier Langella <olivier.langella@u-psud.fr>  Thu, 16 Aug 2018 10:17:04 +0200

libodsstream (0.6.2-2) stretch; urgency=medium

  * read anchor text value (bug fix)

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 14 Aug 2018 15:43:22 +0200

libodsstream (0.6.2-1) stretch; urgency=medium

  * read anchor text value

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 14 Aug 2018 14:23:10 +0200

libodsstream (0.6.1-1) stretch; urgency=medium

  * bug fix on odscolorscale

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 15 May 2018 12:52:23 +0200

libodsstream (0.6.0-2) stretch; urgency=medium

  * API fix

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 30 Apr 2018 17:06:43 +0200

libodsstream (0.6.0-1) stretch; urgency=medium

  * code refactoring, new API

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 30 Apr 2018 13:32:31 +0200

libodsstream (0.5.2-2) stretch; urgency=medium

  * fix documentation install problem

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 14 Apr 2018 17:15:52 +0200

libodsstream (0.5.2-1) stretch; urgency=medium

  * ODS color scale fixed for sheetnames containing spaces

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 09 Apr 2018 13:42:30 +0200

libodsstream (0.5.1-1) stretch; urgency=medium

  * new color scale conditional format feature

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sun, 11 Mar 2018 08:02:15 +0100

libodsstream (0.4.13-3) stretch; urgency=medium

  * fix rename problem using virtual package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 12 Feb 2018 10:57:44 +0100

libodsstream (0.4.13-2) stretch; urgency=medium

  * add a conflict on the old binary package

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 12 Feb 2018 09:23:50 +0100

libodsstream (0.4.13-1) stretch; urgency=medium

  * newer debian configuration files

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sun, 11 Feb 2018 16:01:22 +0100

libodsstream (0.4.12-1) stretch; urgency=medium

  [ Olivier Langella ]
  * first attempt to build an official debian package

  [ Andreas Tille ]
  * Add watch file
  * Set Debichem team as maintainer
  * Add Vcs fields
  * cme fix dpkg-control
  * source/format: 3.0 (quilt)
  * remove dbgsym packages
  * d/rules: short dh
  * Add missing Build-Depends: cmake
  * debhelper 10
  * Standards-Version: 4.1.2

  [ Olivier Langella ]
  * newer debian configuration files

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 14 Nov 2017 14:53:53 +0100

=== debian/control ===
Source: libodsstream
Maintainer: Olivier Langella <olivier.langella@u-psud.fr>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               d-shlibs,
               qtbase5-dev,
               libquazip5-dev,
               qtbase5-dev,
               doxygen
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/debichem/packages/libodsstream.git
Vcs-Git: https://anonscm.debian.org/git/debichem/packages/libodsstream.git
Homepage: http://pappso.inra.fr/bioinfo

Package: libodsstream-qt5
Depends: libodsstream-qt5-0, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: extra
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libodsstream-qt5-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libodsstream-qt5 ( << 0.4.13 )
Replaces: libodsstream-qt5 ( << 0.4.13 )
Breaks: libodsstream-qt5 ( << 0.4.13 )
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the shared library.

Package: libodsstream-dev
Depends: libodsstream-qt5-dev, ${misc:Depends}
Architecture: all
Section: oldlibs
Priority: extra
Description: transitional package
 This is a transitional package. It can safely be removed.

Package: libodsstream-qt5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends},
         libquazip-dev
Conflicts: libodsstream-dev ( << 0.4.13 )
Replaces: libodsstream-dev ( << 0.4.13 )
Breaks: libodsstream-dev ( << 0.4.13 )
Description: C++ library to read or write ODS files (development files)
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the header files of the library.

Package: libodsstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: doxygen documentation of the ODSstream library
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package provides the documentation of the library.

Package: ods2tsv
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends},
         libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ODS to TSV file converter
 Simple command line interface utility that takes one or more ods files
 as input and convert them into tabulated separated value (simple text files).
 Each ods file will create an output directory of the same name, containing all
 the spreadsheets (one tsv file per spreadsheet).

## libodsstream 0.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -24,8 +24,8 @@
 # 
 
 SET (LIBODSSTREAM_MAJOR_VERSION 0)
-SET (LIBODSSTREAM_MINOR_VERSION 6)
-SET (LIBODSSTREAM_PATCH_LEVEL   2)
+SET (LIBODSSTREAM_MINOR_VERSION 7)
+SET (LIBODSSTREAM_PATCH_LEVEL   0)
 SET (LIBODSSTREAM_VERSION
   "${LIBODSSTREAM_MAJOR_VERSION}.${LIBODSSTREAM_MINOR_VERSION}.${LIBODSSTREAM_PATCH_LEVEL}")
 SET (LIBODSSTREAM_LIB_NAME "libodsstream")
@@ -66,6 +66,7 @@
   MESSAGE("compiling as release with debug info version")
 ENDIF( CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo" )
 
+set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O3 -g -DNDEBUG -DQT_NO_DEBUG -Wall -Wextra")
 
 SET(CPACK_CMAKE_GENERATOR "Unix Makefiles")
 SET(CPACK_GENERATOR "STGZ;TGZ;TZ")
@@ -203,6 +204,12 @@
 	COMMENT "Creating Debian package" VERBATIM
 )
 
+add_custom_target(lintian
+    lintian -IEi --pedantic ${changesdeb}
+    DEPENDS deb
+    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
+    COMMENT "lintian check" VERBATIM
+)
 
 IF(MAKE_TEST)
   ENABLE_TESTING()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+configure_file (${CMAKE_SOURCE_DIR}/src/odsstream/config.h.cmake ${CMAKE_SOURCE_DIR}/src/odsstream/config.h)
 
 if (MINGW)
 else (MINGW)
@@ -32,6 +33,7 @@
   odsstream/odsdocwriter.cpp
   odsstream/tsvdirectorywriter.cpp
   odsstream/tsvoutputstream.cpp
+  odsstream/tsvreader.cpp
 )
 
 
@@ -40,11 +42,14 @@
   ods2csv.cpp
 )
 
+SET(TSV2ODS_CPP_FILES 
+  tsv2ods.cpp
+)
+
 
 
 configure_file (${CMAKE_SOURCE_DIR}/src/config.h.cmake ${CMAKE_SOURCE_DIR}/src/config.h)
 
-IF (USEQT5)
     MESSAGE ("LIBODSSTREAM_LIB_SOVERSION: ${LIBODSSTREAM_LIB_SOVERSION}")
   #qt5-default qtbase5-dev
   FIND_PACKAGE( Qt5Core REQUIRED )
@@ -93,74 +98,19 @@
 
   INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/ods2tsv DESTINATION bin)
 
-ENDIF(USEQT5)
+  
+   
+  ADD_EXECUTABLE(tsv2ods ${TSV2ODS_CPP_FILES})
+  target_include_directories (tsv2ods PUBLIC ${Qt5Core_INCLUDES} "${CMAKE_SOURCE_DIR}/src" )
+  SET_TARGET_PROPERTIES(tsv2ods
+      PROPERTIES OUTPUT_NAME tsv2ods
+      CLEAN_DIRECT_OUTPUT 1
+      CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}"
+    )
+  TARGET_LINK_LIBRARIES(tsv2ods odsstream-shared-qt5 ${Qt5Core_LIBRARIES})
 
-IF (USEQT4)
-  #qt5-default qtbase5-dev
-  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
-  
-  MESSAGE ("QT_DEFINITIONS ${QT_DEFINITIONS}" )
-  MESSAGE ("QT_INCLUDE_DIR ${QT_INCLUDE_DIR}" )
-  MESSAGE ("QT_QTCORE_INCLUDE_DIR ${QT_QTCORE_INCLUDE_DIR}" )
-  MESSAGE ("QT_QTXML_INCLUDE_DIR ${QT_QTXML_INCLUDE_DIR}" )
-  
-
-  # Build the static lib
-  ADD_LIBRARY(odsstream-static-qt4 STATIC ${CPP_FILES})
-  if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
-       target_include_directories (odsstream-static-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
-   else()
-       include_directories(${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
-   endif()
-  IF (MINGW)
-    SET_TARGET_PROPERTIES(odsstream-static-qt4
-      PROPERTIES OUTPUT_NAME odsstream-qt4
-      CLEAN_DIRECT_OUTPUT 1
-      )
-  ELSE (MINGW)
-    SET_TARGET_PROPERTIES(odsstream-static-qt4
-      PROPERTIES OUTPUT_NAME odsstream-qt4
-      CLEAN_DIRECT_OUTPUT 1
-      COMPILE_DEFINITIONS "${QT_DEFINITIONS}"
-      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
-      )
-  ENDIF (MINGW)
-  TARGET_LINK_LIBRARIES(odsstream-static-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})
-
-  # Build the shared lib
-  ADD_LIBRARY(odsstream-shared-qt4 SHARED ${CPP_FILES})
-  if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
-    target_include_directories (odsstream-shared-qt4 PUBLIC ${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
-
-   else()
-       include_directories(${QUAZIP_INCLUDE_DIR} ${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR} ${QT_QTXML_INCLUDE_DIR} ${QT_QTGUI_INCLUDE_DIR})
-   endif()
-  IF(MINGW)
-    SET_TARGET_PROPERTIES(odsstream-shared-qt4
-      PROPERTIES OUTPUT_NAME odsstream-qt4
-      CLEAN_DIRECT_OUTPUT 1
-      VERSION ${LIBODSSTREAM_VERSION}
-      SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
-      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
-      )
-  ELSE (MINGW)
-    SET_TARGET_PROPERTIES(odsstream-shared-qt4
-      PROPERTIES OUTPUT_NAME odsstream-qt4
-      CLEAN_DIRECT_OUTPUT 1
-      VERSION ${LIBODSSTREAM_VERSION}
-      SOVERSION ${LIBODSSTREAM_MAJOR_VERSION}
-      COMPILE_DEFINITIONS "${QT_DEFINITIONS}"
-      #INCLUDE_DIRECTORIES "${QT_INCLUDE_DIR} ${QT_QTCORE_INCLUDE_DIR}"
-      )
-  ENDIF (MINGW)
-  TARGET_LINK_LIBRARIES(odsstream-shared-qt4 ${LIBS} ${QT_QTCORE_LIBRARY} ${QT_QTXML_LIBRARY}  ${QUAZIP_QT4_LIBRARIES} ${QT_QTGUI_LIBRARY})
-
-  # Install libs
-  INSTALL(TARGETS odsstream-shared-qt4 LIBRARY DESTINATION lib${LIB_SUFFIX})
-  INSTALL(TARGETS odsstream-static-qt4 DESTINATION lib${LIB_SUFFIX})
-
-ENDIF(USEQT4)
-
+  INSTALL(PROGRAMS ${CMAKE_BINARY_DIR}/src/tsv2ods DESTINATION bin)
+ 
 
 
 # Install headers

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -38,50 +38,36 @@
   
   )
   
-
-IF (USEQT5)
-  IF (USEQT4)
-     SET (USEQT5 1)
-     SET (USEQT4 0)
-  ENDIF(USEQT4)
-ENDIF(USEQT5)
-
-IF (USEQT5)
   #Find the bpp-core library library:
   TEST_FIND_LIBRARY(LIBS odsstream-qt5 odsstream/odsdocreader.h)
 
   FIND_PACKAGE( Qt5Core REQUIRED )
   FIND_PACKAGE( Qt5Xml REQUIRED )
   FIND_PACKAGE( Qt5Gui REQUIRED )
-  INCLUDE_DIRECTORIES(${Qt5Core_INCLUDES} ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES})
+  INCLUDE_DIRECTORIES(${Qt5Core_INCLUDES} ${Qt5Xml_INCLUDES} ${Qt5Gui_INCLUDES} ${QUAZIP_INCLUDE_DIR})
   SET (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ${Qt5Xml_EXECUTABLE_COMPILE_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS}")
  
   set(QTLIBS ${Qt5Core_LIBRARIES} ${Qt5Xml_LIBRARIES} ${Qt5Gui_LIBRARIES})
-ENDIF(USEQT5)
-
-IF (USEQT4)
-  #Find the bpp-core library library:
-  TEST_FIND_LIBRARY(LIBS odsstream-qt4 odsstream/odsdocreader.h)
-
-  FIND_PACKAGE( Qt4 COMPONENTS QTCORE QTXML QTGUI REQUIRED )
-  
-  INCLUDE( ${QT_USE_FILE} )
-  set(QTLIBS "${QT_LIBRARIES}")
-ENDIF(USEQT4)
 
 ADD_EXECUTABLE(test_ods test_ods.cpp)
 MESSAGE ("library: ${LIBS}")
-TARGET_LINK_LIBRARIES(test_ods ${LIBS} ${QTLIBS})
+TARGET_LINK_LIBRARIES(test_ods ${LIBS} ${QTLIBS} ${QUAZIP_QT5_LIBRARIES})
 ADD_TEST(test_ods "test_ods")
 
 
 ADD_EXECUTABLE(test_tsv test_tsv.cpp)
-TARGET_LINK_LIBRARIES(test_tsv ${LIBS} ${QTLIBS})
+TARGET_LINK_LIBRARIES(test_tsv ${LIBS} ${QTLIBS} ${QUAZIP_QT5_LIBRARIES})
 ADD_TEST(test_tsv "test_tsv")
 
 
+
+ADD_EXECUTABLE(test_zlib test_zlib.cpp)
+TARGET_LINK_LIBRARIES(test_zlib ${LIBS} ${QTLIBS} ${QUAZIP_QT5_LIBRARIES})
+ADD_TEST(test_zlib "test_zlib")
+
+
 IF(UNIX)
-  SET_PROPERTY(TEST test_ods test_tsv ${TEST_LIST} PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
+  SET_PROPERTY(TEST test_ods test_tsv test_zlib ${TEST_LIST} PROPERTY ENVIRONMENT "LD_LIBRARY_PATH=$ENV{LD_LIBRARY_PATH}:../src")
 ENDIF()
 
 IF(WIN32)

=== debian/changelog ===
libodsstream (0.7.0-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:06:20 +0100

libodsstream (0.7.0-3) unstable; urgency=medium

  * Team upload.
  * Depends libodsstream-qt5-dev: s/libquazip-dev/libquazip5-dev/
    Closes: #939066
  * debhelper-compat 12
  * ods2tsv Multi-Arch: foreign
  * Standards-Version: 4.4.0
  * Remove trailing whitespace in debian/changelog
  * Remove trailing whitespace in debian/control
  * Trim trailing whitespace.
  * d/control: Remove redundant Conflicts since Breaks is sufficient,
    rather add Provides instead

 -- Andreas Tille <tille@debian.org>  Mon, 09 Sep 2019 09:05:33 +0200

libodsstream (0.7.0-2) unstable; urgency=medium

  * new API to read text files (TSV, CSV...)

  * fixes to the packaging in various ways.

 -- Filippo Rusconi <lopippo@debian.org>  Fri, 15 Feb 2019 16:53:40 +0100

libodsstream (0.6.3-1) stretch; urgency=medium

  * conformance with ODF validator

 -- Olivier Langella <olivier.langella@u-psud.fr>  Sat, 15 Sep 2018 22:19:19 +0200

=== debian/control ===
Source: libodsstream
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               d-shlibs,
               qtbase5-dev,
               libquazip5-dev,
               doxygen
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/debichem-team/libodsstream
Vcs-Git: https://salsa.debian.org/debichem-team/libodsstream.git
Homepage: http://pappso.inra.fr/bioinfo

Package: libodsstream-qt5-0
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libodsstream-qt5 ( << 0.4.13 )
Replaces: libodsstream-qt5 ( << 0.4.13 )
Provides: libodsstream-qt5
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the shared library.

Package: libodsstream-qt5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends},
         libquazip5-dev
Breaks: libodsstream-dev ( << 0.4.13 )
Replaces: libodsstream-dev ( << 0.4.13 )
Provides: libodsstream-dev
Description: C++ library to read or write ODS files (development files)
 libodsstream provides a simple way to read and write Open
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the header files of the library.

Package: libodsstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: doxygen documentation of the ODSstream library
 libodsstream provides a simple way to read and write Open
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package provides the documentation of the library.

Package: ods2tsv
Architecture: any
Multi-Arch: foreign
Section: text
Depends: ${shlibs:Depends},
         libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ODS to TSV file converter
 Simple command line interface utility that takes one or more ods files
 as input and convert them into tabulated separated value (simple text files).
 Each ods file will create an output directory of the same name, containing all
 the spreadsheets (one tsv file per spreadsheet).

=== debian/watch ===
version=4

https://sourcesup.renater.fr/frs/?group_id=875 .*/libodsstream-@ANY_VERSION@@ARCHIVE_EXT@

## libodsstream 0.7.1-1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 
 SET (LIBODSSTREAM_MAJOR_VERSION 0)
 SET (LIBODSSTREAM_MINOR_VERSION 7)
-SET (LIBODSSTREAM_PATCH_LEVEL   0)
+SET (LIBODSSTREAM_PATCH_LEVEL   1)
 SET (LIBODSSTREAM_VERSION
   "${LIBODSSTREAM_MAJOR_VERSION}.${LIBODSSTREAM_MINOR_VERSION}.${LIBODSSTREAM_PATCH_LEVEL}")
 SET (LIBODSSTREAM_LIB_NAME "libodsstream")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,7 @@
   odsstream/writer/structure/settingsxml.cpp
   odsstream/writer/structure/manifestxml.cpp
   odsstream/odsdocwriter.cpp
+  odsstream/qtablewriter.cpp
   odsstream/tsvdirectorywriter.cpp
   odsstream/tsvoutputstream.cpp
   odsstream/tsvreader.cpp

=== debian/changelog ===
libodsstream (0.7.1-1) stretch; urgency=medium

  * new QtableWriter object

 -- Olivier Langella <olivier.langella@u-psud.fr>  Mon, 18 Mar 2019 10:52:14 +0100

libodsstream (0.7.0-2) stretch; urgency=medium

  * new API to read text files (TSV, CSV...)

 -- Olivier Langella <olivier.langella@u-psud.fr>  Tue, 11 Dec 2018 10:49:23 +0100

=== debian/control ===
Source: libodsstream
Maintainer: Olivier Langella <olivier.langella@u-psud.fr>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 10),
               cmake,
               d-shlibs,
               qtbase5-dev,
               libquazip5-dev,
               qtbase5-dev,
               doxygen
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/debichem-team/libodsstream
Vcs-Git: https://salsa.debian.org/debichem-team/libodsstream.git
Homepage: http://pappso.inra.fr/bioinfo

Package: libodsstream-qt5-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Conflicts: libodsstream-qt5 ( << 0.4.13 )
Replaces: libodsstream-qt5 ( << 0.4.13 )
Breaks: libodsstream-qt5 ( << 0.4.13 )
Pre-Depends: ${misc:Pre-Depends}
Description: C++ library to read or write ODS files
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the shared library.

Package: libodsstream-qt5-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends},
         libquazip-dev
Conflicts: libodsstream-dev ( << 0.4.13 )
Replaces: libodsstream-dev ( << 0.4.13 )
Breaks: libodsstream-dev ( << 0.4.13 )
Description: C++ library to read or write ODS files (development files)
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package contains the header files of the library.

Package: libodsstream-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: doxygen documentation of the ODSstream library
 libodsstream provides a simple way to read and write Open 
 Document Spreadsheet files using streams only to be memory efficient.
 .
 This package provides the documentation of the library.

Package: ods2tsv
Architecture: any
Section: text
Multi-Arch: no
Depends: ${shlibs:Depends},
         libodsstream-qt5-0 (= ${binary:Version}),
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: ODS to TSV file converter
 Simple command line interface utility that takes one or more ods files
 as input and convert them into tabulated separated value (simple text files).
 Each ods file will create an output directory of the same name, containing all
 the spreadsheets (one tsv file per spreadsheet).

## libodsstream 0.7.8

=== CMakeLists.txt ===
# CMake script for PAPPSOms++ library
# Authors: Olivier Langella & Filippo Rusconi
# Created: 03/03/2015
# Rework: April 2020 (Coronavirus confinement)

############################################################
############################################################
# Basic information about project

set(PROJECT odsstream)
project(${PROJECT} CXX C)

set(LIBODSSTREAM_VERSION_MAJOR "0")
set(LIBODSSTREAM_VERSION_MINOR "7")
set(LIBODSSTREAM_VERSION_PATCH "8")
set(LIBODSSTREAM_LIB_NAME "libodsstream")
set(LIBODSSTREAM_VERSION "${LIBODSSTREAM_VERSION_MAJOR}.${LIBODSSTREAM_VERSION_MINOR}.${LIBODSSTREAM_VERSION_PATCH}")
set(VERSION 0.7.8)
set(LIBODSSTREAM_LIB_VERSION ${LIBODSSTREAM_VERSION})
set(LIBODSSTREAM_LIB_SOVERSION ${LIBODSSTREAM_VERSION_MAJOR})

# Command to enable debug and tests
# cmake -DCMAKE_BUILD_TYPE=Debug  -DMAKE_TEST=1 -DUSEPAPPSOTREE=0 ..

#############################################################
#############################################################
# CMake configuration
cmake_minimum_required(VERSION 3.0)

include(GNUInstallDirs)

set(HOME_DEVEL_DIR $ENV{HOME}/devel)
message("\n${BoldRed}The devel directory where all the development projects
should reside: ${HOME_DEVEL_DIR}.${ColourReset}\n")

# Add folder where are supportive functions
set(CMAKE_UTILS_PATH ${CMAKE_SOURCE_DIR}/CMakeStuff)
set(CMAKE_TOOLCHAINS_PATH ${CMAKE_UTILS_PATH}/toolchains)
set(CMAKE_MODULE_PATH ${CMAKE_UTILS_PATH}/modules)
#message("CMAKE_MODULE_PATH:" ${CMAKE_MODULE_PATH})


# This include must come before all the others
# It must include the config-generated config.h file
# before the others.
#include_directories(${CMAKE_BINARY_DIR})

# And now the source directory contains the .h|.hpp files for its .cpp files.
#include_directories(${CMAKE_SOURCE_DIR})

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include the system's uname that fills in SYSTEM_UNAME_S.
# Sets WIN64 if SYSTEM_UNAME_S is "^.*MING64.*"
include(${CMAKE_UTILS_PATH}/systemUname.cmake)

# Include the various colors we want to use in the output
include(${CMAKE_UTILS_PATH}/outputColors.cmake)

set(CMAKE_COLOR_MAKEFILE ON)
set(CMAKE_VERBOSE_MAKEFILE ON)
# Instruct CMake to run moc automatically when needed.
set(CMAKE_AUTOMOC ON)

message("\n${BoldRed}Configuring build for project ${PROJECT}${ColourReset}\n")

# This export will allow using the flags to be used by
# youcompleteme (vim plugin).
set(CMAKE_EXPORT_COMPILE_COMMANDS 1)

if(EXISTS "${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json" )
	execute_process( COMMAND cmake -E copy_if_different
		${CMAKE_CURRENT_BINARY_DIR}/compile_commands.json
		${CMAKE_CURRENT_SOURCE_DIR}/compile_commands.json
		)
endif()


# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#############################################################
# We do not want warnings for unknown pragmas:
message(STATUS "Setting definition -Wno-unknown-pragmas.${ColourReset}")
add_definitions(-Wno-unknown-pragmas)
# Enable warnings and possibly treat them as errors
message(STATUS "${BoldGreen}Setting definition -Wall.${ColourReset}")
add_definitions(-Wall)
message(STATUS "${BoldGreen}Setting definition -Wextra.${ColourReset}")
add_definitions(-Wextra)
#message(STATUS "${BoldGreen}Setting definition -pedantic.${ColourReset}")
#add_definitions(-pedantic)

if(WARN_AS_ERROR)
	message(STATUS "${BoldYellow}Setting definition -Werror.${ColourReset}")
	add_definitions(-Werror)
endif()

message(STATUS "${BoldRed}CMAKE_SOURCE_DIR: ${CMAKE_SOURCE_DIR}${ColourReset}")


#############################################################
#############################################################
# Platform-specific CMake configuration
if(MXE)

	# Run the following cmake command line:
	# x86_64-w64-mingw32.shared-cmake -DCMAKE_BUILD_TYPE=Release -DMXE=1 ../development
	include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain.cmake)
	#include(${CMAKE_TOOLCHAINS_PATH}/mxe-toolchain-olivier.cmake)

	# Set the name to the systemUname variable because in this situation that name
	# is not found, it it passed as a flag in the command line.
	set(SYSTEM_UNAME_S "mxe")

elseif(UNIX AND NOT APPLE)

	# Run the following cmake command line:
	# cmake -DCMAKE_BUILD_TYPE=Debug

	include(${CMAKE_TOOLCHAINS_PATH}/unix-toolchain.cmake)

elseif(WIN32 OR _WIN32)

	# Run the following cmake command line:
	# cmake -DCMAKE_BUILD_TYPE=Release ../development

	include(${CMAKE_TOOLCHAINS_PATH}/win10-mingw64-toolchain.cmake)

elseif(APPLE)

	# Run the following cmake command line:
	# cmake -DCMAKE_BUILD_TYPE=Release ../development

	include(${CMAKE_TOOLCHAINS_PATH}/apple-macport-toolchain.cmake)

endif()

message("")
message(STATUS "${BoldGreen}Starting configuration of ${PROJECT}${ColourReset}")
message("")
message(STATUS "${BoldYellow}The build toolchain is: ${SYSTEM_UNAME_S}${ColourReset}")
message("")


#############################################################
#############################################################
# Essential software configuration
message(STATUS "CMAKE_CURRENT_BINARY_DIR: " ${CMAKE_CURRENT_BINARY_DIR})

if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release CACHE STRING
		"Type of build, options are: None, Debug, Release, RelWithDebInfo, MinSizeRel."
		FORCE)
endif(NOT CMAKE_BUILD_TYPE)

if(CMAKE_BUILD_TYPE MATCHES "Release")
	message(STATUS "Compiling in release mode.")
	add_definitions("-DQT_NO_DEBUG_OUTPUT")
endif()

if(CMAKE_BUILD_TYPE MATCHES "Debug")
	message(STATUS "Compiling in debug mode with MAKE_TEST: ${MAKE_TEST}.")
	message(STATUS "Add definition -ggdb3 to format debug output for GDB.")
	add_definitions(-ggdb3)
endif()

if(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")
	message(STATUS "Compiling in release with debug info mode.")
endif(CMAKE_BUILD_TYPE MATCHES "RelWithDebInfo")

message(STATUS "${BoldYellow}CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}.${ColourReset}")



set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
set(CPACK_GENERATOR "STGZ;TGZ;TZ")
set(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
#set(CPACK_PACKAGE_DESCRIPTION_FILE ${LIBODSSTREAM_SOURCE_DIR}/COPYING)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "library to read and write ODS files using streams")
set(CPACK_PACKAGE_EXECUTABLES "libodsstream")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")
set(CPACK_SYSTEM_NAME "Linux-i686")
set(CPACK_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}-${CPACK_SYSTEM_NAME}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "libodsstream ${LIBODSSTREAM_VERSION}")
set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "libodsstream ${LIBODSSTREAM_VERSION}")
set(CPACK_PACKAGE_NAME "libodsstream")
set(CPACK_PACKAGE_VENDOR "PAPPSO")
set(CPACK_PACKAGE_VERSION ${LIBODSSTREAM_VERSION})
set(CPACK_RESOURCE_FILE_LICENSE ${CMAKE_SOURCE_DIR}/debian/copyright)
set(CPACK_RESOURCE_FILE_README ${CMAKE_SOURCE_DIR}/README)
set(CPACK_RESOURCE_FILE_WELCOME ${CMAKE_SOURCE_DIR}/README)
set(CPACK_SOURCE_GENERATOR "TGZ;TZ")
set(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
set(CPACK_SOURCE_STRIP_FILES "")
set(CPACK_SYSTEM_NAME "Linux-i686")
set(CPACK_TOPLEVEL_TAG "Linux-i686")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "libodsstream-${LIBODSSTREAM_VERSION}")


set(CPACK_SOURCE_IGNORE_FILES 
	".*\\\\.tar\\\\.gz"
	"moc_.*cxx"
	"\\\\.#.*"
	".*\\\\.aux"
	".*\\\\.bbl"
	".*\\\\.blg"
	".*\\\\.log"
	".*\\\\.out"
	".*\\\\.toc"
	"/devel_archives/"
	"/doc\\\\/html/"
	"/doc\\\\/latex/"
	"Makefile"
	"install_manifest.txt"
	"CMakeCache.txt"
	"CPackConfig.cmake"
	"CPackSourceConfig.cmake"
	"/CMakeFiles/"
	"/_CPack_Packages/"
	"/Debug/"
	"/Release/"
	"/tests/"
	"/\\\\.externalToolBuilders/"
	"/\\\\.git/"
	"/\\\\.kdev4/"
	"/\\\\.settings/"
	"Makefile"
	"\\\\.gitignore"
	"\\\\.cdtbuild"
	"\\\\.cdtproject"
	"\\\\.project"
	"\\\\.cproject"
	"/win32/"
	"/win64/"
	"/build/"
	"/buildwin64/"
	"/cbuild/"
	"/wbuild/"
	"/bin/"
	"/buildmingw/"
	"test\\\\.ods"
	"buildwin32.cmd"
	"libodsstream.so"
	"OpenDocument-v1.0-os.pdf"
	)
# to create a TGZ archive of the  source code type shell command
# cpack -G TGZ --config CPackSourceConfig.cmake 

# dpkg-buildpackage -rfakeroot -k7BEF3B25

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes


#dch -Dstretch "message"
#cmake ..
#make deb
# scp libodsstream* proteus:/var/www/apt/incoming
# scp ods2tsv* proteus:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default


#dpkg-deb -x libodsstream-qt4_0.3.0-3_amd64.deb libodsstream-qt4_0.3.0-3
#dpkg-gensymbols -v0 -plibodsstream-qt4 -Plibodsstream-qt4_0.3.0-3 -Osymbols
#cp symbols ../debian/libodsstream-qt4.symbols
#dpkg-deb -x libodsstream-qt5_0.3.0-3_amd64.deb libodsstream-qt5_0.3.0-3
#dpkg-gensymbols -v0 -plibodsstream-qt5 -Plibodsstream-qt5_0.3.0-3 -Osymbols
#cp symbols ../debian/libodsstream-qt5.symbols

#MESSAGE("configuring file ${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake")

#configure_file (${LIBODSSTREAM_SOURCE_DIR}/src/config.h.cmake ${LIBODSSTREAM_SOURCE_DIR}/src/config.h)



set(CPACK_PACKAGE_EXECUTABLES "libodsstream" "libodsstream")


# for debian package :
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Olivier Langella <olivier.langella@u-psud.fr>")
set(DEBIAN_PACKAGE_BUILDS_DEPENDS "Olivier Langella <olivier.langella@u-psud.fr>")


include(CPack)

add_subdirectory (src)

add_subdirectory (doc)

add_custom_target(targz
	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz libodsstream-${LIBODSSTREAM_VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating .tar.gz" VERBATIM
	)


add_custom_target(deb
	ln -s libodsstream-${LIBODSSTREAM_VERSION}.tar.gz libodsstream_${LIBODSSTREAM_VERSION}.orig.tar.gz && cd libodsstream-${LIBODSSTREAM_VERSION} && dpkg-buildpackage -sa
	DEPENDS targz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating Debian package" VERBATIM
	)

add_custom_target(lintian
	lintian -IEi --pedantic ${changesdeb}
	DEPENDS deb
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "lintian check" VERBATIM
	)

if(MAKE_TEST)
	enable_testing()
	include(CTest)
	if(BUILD_TESTING)
		add_subdirectory(test)
	endif(BUILD_TESTING)
endif(MAKE_TEST)


# message(STATUS CMAKE_MODULE_PATH: ${CMAKE_MODULE_PATH})

# Install cmake module
install(FILES ${CMAKE_MODULE_PATH}/FindOdsStream.cmake DESTINATION share/cmake/Modules)
# Install cmake config
configure_file (${CMAKE_MODULE_PATH}/OdsStreamConfig.cmake ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake)
install(FILES ${CMAKE_SOURCE_DIR}/OdsStreamConfig.cmake DESTINATION lib${LIB_SUFFIX}/cmake/odsstream)
#configure_file (${CMAKE_SOURCE_DIR}/debian/rules.cmake ${CMAKE_SOURCE_DIR}/debian/rules @ONLY)
